require "helper"
require "twirl/item"

class ItemTest < Minitest::Test
  def test_initialize
    client = Object.new
    item = build(:item, "events", "data", client)
    assert_equal "events", item.key
    assert_equal "data",   item.value
    assert_equal client,   item.client
  end

  def test_close
    key = "events"
    client = Minitest::Mock.new
    client.expect :close, :closed, [key]

    item = build(:item, key, "data", client)
    assert_equal :closed, item.close

    client.verify
  end

  def test_abort
    key = "events"
    client = Minitest::Mock.new
    client.expect :abort, :aborted, [key]

    item = build(:item, key, "data", client)
    assert_equal :aborted, item.abort

    client.verify
  end

  def test_eql
    client = Object.new
    item = build(:item, "events", "data", client)

    assert item.eql?(build(:item, "events", "data", client))

    assert ! item.eql?(build(:item, "events", "data", Object.new))
  end
end
